diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index c0ef84e18..93f52d515 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -673,50 +682,50 @@ public class RenderGlobal
                 GL11.glDisable(GL11.GL_FOG);
                 GL11.glColorMask(false, false, false, false);
                 GL11.glDepthMask(false);
-                checkOcclusionQueryResult(byte0, max);
+                checkQueryResults(from, to);
                 GL11.glPushMatrix();
-                float f = 0.0F;
-                float f1 = 0.0F;
-                float f2 = 0.0F;
-                for(int k1 = byte0; k1 < max; k1++)
+                float xo = 0.0F;
+                float yo = 0.0F;
+                float zo = 0.0F;
+                for(int ix = from; ix < to; ix++)
                 {
-                    if(sortedChunkRenderers[k1].isEmpty())
+                    if(sortedChunkRenderers[ix].isEmpty())
                     {
-                        sortedChunkRenderers[k1].visible = false;
+                        sortedChunkRenderers[ix].visible = false;
                         continue;
                     }
-                    if(!sortedChunkRenderers[k1].visible)
+                    if(!sortedChunkRenderers[ix].visible)
                     {
-                        sortedChunkRenderers[k1].occlusionVisible = true;
+                        sortedChunkRenderers[ix].occlusionVisible = true;
                     }
-                    if(!sortedChunkRenderers[k1].visible || sortedChunkRenderers[k1].occlusionQuerying)
+                    if(!sortedChunkRenderers[ix].visible || sortedChunkRenderers[ix].occlusionQuerying)
                     {
                         continue;
                     }
-                    float f3 = MathHelper.sqrt_float(sortedChunkRenderers[k1].distanceToCameraSquared(camera));
-                    int l1 = (int)(1.0F + f3 / 128F);
-                    if(cloudOffsetX % l1 != k1 % l1)
+                    float dist = MathHelper.sqrt_float(sortedChunkRenderers[ix].distanceToCameraSquared(camera));
+                    int frequency = (int)(1.0F + dist / 128F);
+                    if(ticks % frequency != ix % frequency)
                     {
                         continue;
                     }
-                    ChunkRenderer worldrenderer1 = sortedChunkRenderers[k1];
-                    float f4 = (float)((double)worldrenderer1.xRender - entityPosX);
-                    float f5 = (float)((double)worldrenderer1.yRender - entityPosY);
-                    float f6 = (float)((double)worldrenderer1.zRender - entityPosZ);
-                    float f7 = f4 - f;
-                    float f8 = f5 - f1;
-                    float f9 = f6 - f2;
-                    if(f7 != 0.0F || f8 != 0.0F || f9 != 0.0F)
+                    ChunkRenderer chunkRenderer = sortedChunkRenderers[ix];
+                    float xt = (float)((double)chunkRenderer.xRender - xOff);
+                    float yt = (float)((double)chunkRenderer.yRender - yOff);
+                    float zt = (float)((double)chunkRenderer.zRender - zOff);
+                    float xdd = xt - xo;
+                    float ydd = yt - yo;
+                    float zdd = zt - zo;
+                    if(xdd != 0.0F || ydd != 0.0F || zdd != 0.0F)
                     {
-                        GL11.glTranslatef(f7, f8, f9);
-                        f += f7;
-                        f1 += f8;
-                        f2 += f9;
+                        GL11.glTranslatef(xdd, ydd, zdd);
+                        xo += xdd;
+                        yo += ydd;
+                        zo += zdd;
                     }
-                    ARBOcclusionQuery.glBeginQueryARB(35092 /*GL_SAMPLES_PASSED_ARB*/, sortedChunkRenderers[k1].occlusionId);
-                    sortedChunkRenderers[k1].renderBB();
-                    ARBOcclusionQuery.glEndQueryARB(35092 /*GL_SAMPLES_PASSED_ARB*/);
-                    sortedChunkRenderers[k1].occlusionQuerying = true;
+                    ARBOcclusionQuery.glBeginQueryARB(GL15.GL_SAMPLES_PASSED, sortedChunkRenderers[ix].occlusionId);
+                    sortedChunkRenderers[ix].renderBB();
+                    ARBOcclusionQuery.glEndQueryARB(GL15.GL_SAMPLES_PASSED);
+                    sortedChunkRenderers[ix].occlusionQuerying = true;
                 }
 
                 GL11.glPopMatrix();
@@ -725,127 +734,129 @@ public class RenderGlobal
                 GL11.glEnable(GL11.GL_TEXTURE_2D);
                 GL11.glEnable(GL11.GL_ALPHA_TEST);
                 GL11.glEnable(GL11.GL_FOG);
-                k += renderSortedRenderers(byte0, max, renderPass, partialTick);
-            } while(max < sortedChunkRenderers.length);
+                count += renderChunks(from, to, renderPass, partialTick);
+            } while(to < sortedChunkRenderers.length);
         }
         else
         {
-            k += renderSortedRenderers(0, sortedChunkRenderers.length, renderPass, partialTick);
+            count += renderChunks(0, sortedChunkRenderers.length, renderPass, partialTick);
         }
-        return k;
+        return count;
     }
 
-    private void checkOcclusionQueryResult(int min, int max)
+    private void checkQueryResults(int from, int to)
     {
-        for(int i = min; i < max; i++)
+        for(int i = from; i < to; i++)
         {
             if(!sortedChunkRenderers[i].occlusionQuerying)
             {
                 continue;
             }
-            occlusionResult.clear();
-            ARBOcclusionQuery.glGetQueryObjectuivARB(sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT_AVAILABLE, occlusionResult);
-            if(occlusionResult.get(0) != 0)
+            resultBuffer.clear();
+            ARBOcclusionQuery.glGetQueryObjectuivARB(sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT_AVAILABLE, resultBuffer);
+            if(resultBuffer.get(0) != 0)
             {
                 sortedChunkRenderers[i].occlusionQuerying = false;
-                occlusionResult.clear();
-                ARBOcclusionQuery.glGetQueryObjectuivARB(sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT, occlusionResult);
-                sortedChunkRenderers[i].occlusionVisible = occlusionResult.get(0) != 0;
+                resultBuffer.clear();
+                ARBOcclusionQuery.glGetQueryObjectuivARB(sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT, resultBuffer);
+                sortedChunkRenderers[i].occlusionVisible = resultBuffer.get(0) != 0;
             }
         }
 
     }
 
-    private int renderSortedRenderers(int min, int max, int renderPass, double partialTick)
+    private int renderChunks(int from, int to, int renderPass, double partialTick)
     {
-        glRenderLists.clear();
-        int addedWorldRenderers = 0;
-        for(int i = min; i < max; i++)
+        renderChunks.clear();
+        int count = 0;
+
+        for(int i = from; i < to; i++)
         {
             if(renderPass == 0)
             {
-                renderersLoaded++;
+                totalChunks++;
                 if(sortedChunkRenderers[i].empty[renderPass])
                 {
-                    renderersSkippingRenderPass++;
+                    emptyChunks++;
                 }
                 else if (!sortedChunkRenderers[i].visible)
                 {
-                    renderersBeingClipped++;
+                    offscreenChunks++;
                 }
-                else if (occlusionEnabled && !sortedChunkRenderers[i].occlusionVisible)
+                else if (occlusionCheck && !sortedChunkRenderers[i].occlusionVisible)
                 {
-                    renderersBeingOccluded++;
+                    occludedChunks++;
                 } else
                 {
-                    renderersBeingRendered++;
+                    renderedChunks++;
                 }
             }
-            if(sortedChunkRenderers[i].empty[renderPass] || !sortedChunkRenderers[i].visible || occlusionEnabled && !sortedChunkRenderers[i].occlusionVisible)
+
+            if(sortedChunkRenderers[i].empty[renderPass] || !sortedChunkRenderers[i].visible || occlusionCheck && !sortedChunkRenderers[i].occlusionVisible)
             {
                 continue;
             }
-            int callList = sortedChunkRenderers[i].getList(renderPass);
-            if(callList >= 0)
+            int list = sortedChunkRenderers[i].getList(renderPass);
+            if(list >= 0)
             {
-                glRenderLists.add(sortedChunkRenderers[i]);
-                addedWorldRenderers++;
+                renderChunks.add(sortedChunkRenderers[i]);
+                count++;
             }
         }
 
-        double posX = mc.activeCamera.getX((float) partialTick);
-        double posY = mc.activeCamera.getY((float) partialTick);
-        double posZ = mc.activeCamera.getZ((float) partialTick);
-        int k1 = 0;
-        for (DisplayList displayList : allDisplayLists)
+        double xOff = mc.activeCamera.getX((float) partialTick);
+        double yOff = mc.activeCamera.getY((float) partialTick);
+        double zOff = mc.activeCamera.getZ((float) partialTick);
+        int lists = 0;
+        for (DisplayList displayList : renderLists)
         {
             displayList.clear();
         }
 
-        for (ChunkRenderer chunkRenderer : glRenderLists)
+        for (ChunkRenderer renderer : renderChunks)
         {
-            int displayListIndex = -1;
-            for (int i = 0; i < k1; i++)
+            int list = -1;
+            for (int i = 0; i < lists; i++)
             {
-                if (allDisplayLists[i].isSetToPos(chunkRenderer.xRender, chunkRenderer.yRender, chunkRenderer.zRender))
+                if (renderLists[i].isSetToPos(renderer.xRender, renderer.yRender, renderer.zRender))
                 {
-                    displayListIndex = i;
+                    list = i;
                 }
             }
 
-            if (displayListIndex < 0)
+            if (list < 0)
             {
-                displayListIndex = k1++;
-                allDisplayLists[displayListIndex].setToPos(chunkRenderer.xRender, chunkRenderer.yRender, chunkRenderer.zRender, posX, posY, posZ);
+                list = lists++;
+                renderLists[list].setToPos(renderer.xRender, renderer.yRender, renderer.zRender, xOff, yOff, zOff);
             }
-            allDisplayLists[displayListIndex].addCallToList(chunkRenderer.getList(renderPass));
+            renderLists[list].addCallToList(renderer.getList(renderPass));
         }
 
         if (!mc.gameSettings.fog.value)
         {
             GL11.glDisable(GL11.GL_FOG);
         }
-        callAllDisplayLists(renderPass, partialTick);
+        renderSameAsLast(renderPass, partialTick);
         if (!mc.gameSettings.fog.value)
         {
             GL11.glEnable(GL11.GL_FOG);
         }
-        return addedWorldRenderers;
+        return count;
     }
 
-    public void callAllDisplayLists(int renderPass, double partialTick)
+    public void renderSameAsLast(int renderPass, double partialTick)
     {
-        for (DisplayList displayList : allDisplayLists)
+        for (DisplayList displayList : renderLists)
         {
             displayList.call();
         }
 
     }
 
-    public void updateClouds()
+    public void tick()
     {
-        float windDirection = worldObj.worldType.getWindManager().getWindDirection(worldObj, 0.0f, 500f, 0.0f);
-        float windIntensity = worldObj.worldType.getWindManager().getWindIntensity(worldObj, 0.0f, 500f, 0.0f);
+        float windDirection = world.worldType.getWindManager().getWindDirection(world, 0.0f, 500f, 0.0f);
+        float windIntensity = world.worldType.getWindManager().getWindIntensity(world, 0.0f, 500f, 0.0f);
 
         float dx = -(float) (Math.cos(windDirection * Math.PI * 2) * windIntensity);
         float dz = -(float) (Math.sin(windDirection * Math.PI * 2) * windIntensity);
@@ -863,18 +874,20 @@ public class RenderGlobal
         lastCloudOffsetZ = cloudOffsetZ;
         cloudOffsetX += cloudVelocityX;
         cloudOffsetZ += cloudVelocityZ;
+
+        ticks++;
     }
 
-    public void drawSky(float partialTick)
+    public void renderSky(float partialTick)
     {
         WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(mc.currentWorld.getWorldType());
         if(!worldTypeFX.hasSky() || mc.currentScreen instanceof ScreenModelViewer)
         {
             return;
         }
-        float celestialAngle = worldObj.getCelestialAngle(partialTick);
+        float celestialAngle = world.getCelestialAngle(partialTick);
         GL11.glDisable(GL_TEXTURE_2D);
-        Vec3 skyColor = worldObj.getSkyColor(mc.activeCamera, partialTick);
+        Vec3 skyColor = world.getSkyColor(mc.activeCamera, partialTick);
         float r = (float)skyColor.x;
         float g = (float)skyColor.y;
         float b = (float)skyColor.z;
@@ -883,7 +896,7 @@ public class RenderGlobal
         GL11.glDepthMask(false);
         GL11.glEnable(GL_FOG);
         GL11.glColor3f(r, g, b);
-        GL11.glCallList(glSkyList);
+        GL11.glCallList(skyList);
         GL11.glDisable(GL_FOG);
         GL11.glDisable(GL_ALPHA_TEST);
         GL11.glEnable(GL_BLEND);
@@ -921,7 +934,7 @@ public class RenderGlobal
         GL11.glEnable(GL_TEXTURE_2D);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE);
         GL11.glPushMatrix();
-        float sunAlpha = 1.0F - (worldObj.getCurrentWeather() != null && worldObj.getCurrentWeather() != Weathers.OVERWORLD_CLEAR ? (worldObj.weatherManager.getWeatherIntensity() * worldObj.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
+        float sunAlpha = 1.0F - (world.getCurrentWeather() != null && world.getCurrentWeather() != Weathers.OVERWORLD_CLEAR ? (world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
 
         float x = 0.0F;
         float y = 0.0F;
@@ -943,10 +956,10 @@ public class RenderGlobal
         t.draw();
 
         // Render Rainbow
-        if (worldObj.rainbowTicks > 0 || (!Double.isNaN(rainbowBrightness) && rainbowBrightness > 0)){
+        if (world.rainbowTicks > 0 || (!Double.isNaN(rainbowBrightness) && rainbowBrightness > 0)){
             // Calculates the progress through the rainbow, with peak brightness halfway through its lifespawn
-            final float halfRainbowLength = (worldObj.startingRainbowTicks/2f);
-            float rainbowTimeScalar = 1 - (Math.abs((worldObj.rainbowTicks + partialTick) - halfRainbowLength) / halfRainbowLength);
+            final float halfRainbowLength = (world.startingRainbowTicks/2f);
+            float rainbowTimeScalar = 1 - (Math.abs((world.rainbowTicks + partialTick) - halfRainbowLength) / halfRainbowLength);
 
             // Calculates the potential max rainbow brightness based on time of day
             float timeScalar;
@@ -966,10 +979,10 @@ public class RenderGlobal
             timeScalar *= cutoff;
             timeScalar *= rainbowTimeScalar;
 
-            Weather[] blocked = worldObj.getBlockBiome(MathHelper.floor(mc.thePlayer.x), MathHelper.floor(mc.thePlayer.y), MathHelper.floor(mc.thePlayer.z)).blockedWeathers;
+            Weather[] blocked = world.getBlockBiome(MathHelper.floor(mc.thePlayer.x), MathHelper.floor(mc.thePlayer.y), MathHelper.floor(mc.thePlayer.z)).blockedWeathers;
             boolean isWeatherBlocked = false;
             for (Weather w : blocked){
-                if (w.equals(worldObj.weatherManager.getLastWeather())) {
+                if (w.equals(world.weatherManager.getLastWeather())) {
                     isWeatherBlocked = true;
                     break;
                 }
@@ -1024,12 +1037,12 @@ public class RenderGlobal
         t.addVertexWithUV(-size, -100D, -size, 1.0D, 0.0D);
         t.draw();
 
-        float f17 = worldObj.getStarBrightness(partialTick) * sunAlpha;
+        float f17 = world.getStarBrightness(partialTick) * sunAlpha;
         if(f17 > 0.0F)
         {
             textureManager.loadTexture("/assets/minecraft/textures/colormap/stars/default.png").bind();
             GL11.glColor4f(f17, f17, f17, f17);
-            GL11.glCallList(starGLCallList);
+            GL11.glCallList(starList);
         }
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         GL11.glDisable(GL11.GL_TEXTURE_2D);
@@ -1076,7 +1089,7 @@ public class RenderGlobal
         textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        Vec3 dimensionColor = worldObj.getDimensionColor(mc.activeCamera, partialTick);
+        Vec3 dimensionColor = world.getDimensionColor(mc.activeCamera, partialTick);
         float r = (float)dimensionColor.x;
         float g = (float)dimensionColor.y;
         float b = (float)dimensionColor.z;
@@ -1115,7 +1128,7 @@ public class RenderGlobal
         WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(mc.currentWorld.getWorldType());
     	mc.renderer.beginRenderClouds(partialTick);
     	
-        float celestialAngle = worldObj.getCelestialAngle(partialTick);
+        float celestialAngle = world.getCelestialAngle(partialTick);
         float[] sunriseColor = worldTypeFX.getSunriseColor(celestialAngle, partialTick);
         float rSun = 0.0f, gSun = 0.0f, bSun = 0.0f, aSun = 0.0f;
         if (sunriseColor != null) {
@@ -1125,7 +1138,7 @@ public class RenderGlobal
             aSun = sunriseColor[3] / 2;
         }
 
-        Vec3 dimensionColor = worldObj.getDimensionColor(mc.activeCamera, partialTick);
+        Vec3 dimensionColor = world.getDimensionColor(mc.activeCamera, partialTick);
         final float rDim = (float)dimensionColor.x;
         final float gDim = (float)dimensionColor.y;
         final float bDim = (float)dimensionColor.z;
@@ -1261,81 +1274,88 @@ public class RenderGlobal
     	mc.renderer.endRenderClouds(partialTick);
     }
 
-    public boolean updateRenderers(ICamera camera) {
-        final byte numLayers = 2;
-        final ChunkRendererComparator comparator = new ChunkRendererComparator(camera);
-        final ChunkRenderer[] chunkRenderers = new ChunkRenderer[numLayers];
-        List<ChunkRenderer> rendererList = null;
-        final int numChunkRenderersToUpdate = chunkRenderersToUpdate.size();
-        int renderListSize = 0;
-        for(int i = 0; i < numChunkRenderersToUpdate; i++) {
-            final ChunkRenderer chunkRenderer = chunkRenderersToUpdate.get(i);
-            if(chunkRenderer.distanceToCameraSquared(camera) > 256F) {
-                int layer = 0;
-                while (layer < numLayers && (chunkRenderers[layer] == null || comparator.compare(chunkRenderers[layer], chunkRenderer) <= 0)) {
-                    layer++;
+    public boolean updateDirtyChunks(ICamera camera) {
+        final DirtyChunkRendererSorter dirtyChunkRendererSorter = new DirtyChunkRendererSorter(camera);
+        final ChunkRenderer[] toAdd = new ChunkRenderer[MAX_VISIBLE_REBUILDS_PER_FRAME];
+        List<ChunkRenderer> nearChunks = null;
+
+        final int pendingChunkSize = dirtyChunks.size();
+        int pendingChunkRemoved = 0;
+
+        for(int i = 0; i < pendingChunkSize; i++) {
+            final ChunkRenderer renderer = dirtyChunks.get(i);
+            if(renderer.distanceToCameraSquared(camera) > 1024.0f) {
+                int index = 0;
+
+                while (index < MAX_VISIBLE_REBUILDS_PER_FRAME && (toAdd[index] == null || dirtyChunkRendererSorter.compare(toAdd[index], renderer) <= 0)) {
+                    index++;
                 }
-                if(--layer <= 0) {
+
+                if(--index <= 0) {
                     continue;
                 }
-                for(int i3 = layer; --i3 != 0;) {
-                    chunkRenderers[i3 - 1] = chunkRenderers[i3];
+
+                for(int x = index; --x != 0;) {
+                    toAdd[x - 1] = toAdd[x];
                 }
 
-                chunkRenderers[layer] = chunkRenderer;
+                toAdd[index] = renderer;
                 continue;
             }
-            if(rendererList == null) {
-                rendererList = new ArrayList<>();
+
+            if(nearChunks == null) {
+                nearChunks = new ArrayList<>();
             }
-            renderListSize++;
-            rendererList.add(chunkRenderer);
-            chunkRenderersToUpdate.set(i, null);
+
+            pendingChunkRemoved++;
+            nearChunks.add(renderer);
+            dirtyChunks.set(i, null);
         }
 
-        if(rendererList != null) {
-            if(rendererList.size() > 1) {
-                rendererList.sort(comparator);
+        if(nearChunks != null) {
+            if(nearChunks.size() > 1) {
+                nearChunks.sort(dirtyChunkRendererSorter);
             }
-            for (ChunkRenderer renderer : rendererList){
+            for (ChunkRenderer renderer : nearChunks){
                 renderer.rebuild();
                 renderer.dirty = false;
             }
         }
-        int renderersUpdated = 0;
-        for(int layer = numLayers - 1; layer >= 0; layer--) {
-            ChunkRenderer renderer = chunkRenderers[layer];
-            if(renderer == null) { continue; }
-            if(!renderer.visible && layer != numLayers - 1) {
-                chunkRenderers[layer] = null;
+
+        int secondaryRemoved = 0;
+        for(int i = MAX_VISIBLE_REBUILDS_PER_FRAME - 1; i >= 0; i--) {
+            ChunkRenderer chunkx = toAdd[i];
+            if(chunkx == null) { continue; }
+            if(!chunkx.visible && i != MAX_VISIBLE_REBUILDS_PER_FRAME - 1) {
+                toAdd[i] = null;
                 break;
             }
-            renderer.rebuild();
-            renderer.dirty = false;
-            renderersUpdated++;
+            chunkx.rebuild();
+            chunkx.dirty = false;
+            secondaryRemoved++;
         }
 
-        int renderIndex = 0;
-        int setRenders = 0;
-        label1: for (int size = chunkRenderersToUpdate.size(); renderIndex != size; renderIndex++) {
-            final ChunkRenderer renderer = chunkRenderersToUpdate.get(renderIndex);
+        int cursor = 0;
+        int target = 0;
+        outer: for (int size = dirtyChunks.size(); cursor != size; cursor++) {
+            final ChunkRenderer renderer = dirtyChunks.get(cursor);
             if(renderer == null) { continue; }
-            for(int layer = 0; layer < numLayers; layer++) {
-                if (renderer == chunkRenderers[layer]) {
-                    continue label1;
+            for(int i = 0; i < MAX_VISIBLE_REBUILDS_PER_FRAME; i++) {
+                if (renderer == toAdd[i]) {
+                    continue outer;
                 }
             }
 
-            if(setRenders != renderIndex) {
-                chunkRenderersToUpdate.set(setRenders, renderer);
+            if(target != cursor) {
+                dirtyChunks.set(target, renderer);
             }
-            setRenders++;
+            target++;
         }
 
-        while(--renderIndex >= setRenders) {
-            chunkRenderersToUpdate.remove(renderIndex);
+        while(--cursor >= target) {
+            dirtyChunks.remove(cursor);
         }
-        return numChunkRenderersToUpdate == (renderListSize + renderersUpdated);
+        return pendingChunkSize == (pendingChunkRemoved + secondaryRemoved);
     }
 
     public void drawBlockBreaking(ICamera camera, HitResult hitResult, float partialTick)
@@ -1345,13 +1365,13 @@ public class RenderGlobal
         GL11.glEnable(GL11.GL_ALPHA_TEST);
         GL11.glBlendFunc(770, 1);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, (MathHelper.sin((float)System.currentTimeMillis() / 100F) * 0.2F + 0.4F) * 0.5F);
-        if(damagePartialTime > 0.0F)
+        if(destroyProgress > 0.0F)
         {
             GL11.glBlendFunc(774, 768);
             TextureRegistry.blockAtlas.bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.5F);
             GL11.glPushMatrix();
-            int k = worldObj.getBlockId(hitResult.x, hitResult.y, hitResult.z);
+            int k = world.getBlockId(hitResult.x, hitResult.y, hitResult.z);
             Block<?> block = k <= 0 ? null : Blocks.blocksList[k];
             GL11.glDisable(GL11.GL_ALPHA_TEST);
             GL11.glPolygonOffset(-3F, -3F);
@@ -1375,11 +1395,11 @@ public class RenderGlobal
                 .getDispatch(block)
                 .renderWithOverrideTexture(
                     tessellator,
-                    worldObj,
+                    world,
                     hitResult.x,
                     hitResult.y,
                     hitResult.z,
-                    breakingAnimation[MathHelper.clamp((int)(damagePartialTime * 10F), 0, breakingAnimation.length - 1)]);
+                    breakingAnimation[MathHelper.clamp((int)(destroyProgress * 10F), 0, breakingAnimation.length - 1)]);
             tessellator.draw();
             tessellator.setTranslation(0.0D, 0.0D, 0.0D);
             GL11.glDisable(GL11.GL_ALPHA_TEST);
@@ -1411,17 +1431,17 @@ public class RenderGlobal
             if(hitResult.hitType == HitResult.HitType.TILE)
             {
                 float expand = 0.002F;
-                int j = worldObj.getBlockId(hitResult.x, hitResult.y, hitResult.z);
+                int j = world.getBlockId(hitResult.x, hitResult.y, hitResult.z);
                 if(j > 0)
                 {
-                    BoundingVolume volume = Blocks.blocksList[j].getBoundingVolume(worldObj, hitResult.x, hitResult.y, hitResult.z);
+                    BoundingVolume volume = Blocks.blocksList[j].getBoundingVolume(world, hitResult.x, hitResult.y, hitResult.z);
                     if (volume != null)
                     {
                         drawOutlinedVolume(volume, hitResult.x - offsetX, hitResult.y - offsetY, hitResult.z - offsetZ, expand);
                     }
                     else
                     {
-                        drawOutlinedBoundingBox(Blocks.blocksList[j].getSelectedBoundingBoxFromPool(worldObj, hitResult.x, hitResult.y, hitResult.z).grow(expand, expand, expand).cloneMove(-offsetX, -offsetY, -offsetZ));
+                        drawOutlinedBoundingBox(Blocks.blocksList[j].getSelectedBoundingBoxFromPool(world, hitResult.x, hitResult.y, hitResult.z).grow(expand, expand, expand).cloneMove(-offsetX, -offsetY, -offsetZ));
                     }
                 }
             }
@@ -1444,7 +1464,7 @@ public class RenderGlobal
 		double offsetY = camera.getY(partialTicks);
 		double offsetZ = camera.getZ(partialTicks);
 		float expand = 0.002F;
-		List<AABB> collidingBoundingBoxes = worldObj.getCubes(mc.thePlayer, mc.thePlayer.bb.grow(expand, expand, expand));
+		List<AABB> collidingBoundingBoxes = world.getCubes(mc.thePlayer, mc.thePlayer.bb.grow(expand, expand, expand));
         glColor4f(0.0f, 0.0f, 1.0f, 1.0f);
 		for (AABB aabb : collidingBoundingBoxes) {
 			drawOutlinedBoundingBox(aabb.cloneMove(-offsetX, -offsetY, -offsetZ).grow(expand, expand, expand));
@@ -1454,7 +1474,7 @@ public class RenderGlobal
 		if(mc.thePlayer.getGamemode() == Gamemode.creative) {
 			entityRadius = 100.0f;
 		}
-		List<Entity> entitiesNearby = worldObj.getEntitiesWithinAABBExcludingEntity(null, mc.thePlayer.bb.grow(entityRadius, entityRadius, entityRadius));
+		List<Entity> entitiesNearby = world.getEntitiesWithinAABBExcludingEntity(null, mc.thePlayer.bb.grow(entityRadius, entityRadius, entityRadius));
         for (Entity e : entitiesNearby) {
             glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
             drawInterpolatedEntityBoundingBox(e, e.bb, camera, partialTicks); // Bounds
@@ -1644,41 +1664,42 @@ public class RenderGlobal
         t.draw();
     }
 
-    public void markDirty(int minX, int minY, int minZ, int maxX, int maxY, int maxZ)
+    public void setDirty(int x0, int y0, int z0, int x1, int y1, int z1)
     {
-        int wrMinX = MathHelper.bucketInt(minX, RENDER_CHUNK_SIZE);
-        int wrMinY = MathHelper.bucketInt(minY, RENDER_CHUNK_SIZE);
-        int wrMinZ = MathHelper.bucketInt(minZ, RENDER_CHUNK_SIZE);
-        int wrMaxX = MathHelper.bucketInt(maxX, RENDER_CHUNK_SIZE);
-        int wrMaxY = MathHelper.bucketInt(maxY, RENDER_CHUNK_SIZE);
-        int wrMaxZ = MathHelper.bucketInt(maxZ, RENDER_CHUNK_SIZE);
-        for(int wrX = wrMinX; wrX <= wrMaxX; wrX++)
+        int _x0 = MathHelper.bucketInt(x0, RENDER_CHUNK_SIZE);
+        int _y0 = MathHelper.bucketInt(y0, RENDER_CHUNK_SIZE);
+        int _z0 = MathHelper.bucketInt(z0, RENDER_CHUNK_SIZE);
+        int _x1 = MathHelper.bucketInt(x1, RENDER_CHUNK_SIZE);
+        int _y1 = MathHelper.bucketInt(y1, RENDER_CHUNK_SIZE);
+        int _z1 = MathHelper.bucketInt(z1, RENDER_CHUNK_SIZE);
+        for(int x = _x0; x <= _x1; x++)
         {
-            int realWrX = wrX % renderChunksWide;
-            if(realWrX < 0)
+            int xx = x % xChunks;
+            if(xx < 0)
             {
-                realWrX += renderChunksWide;
+                xx += xChunks;
             }
-            for(int wrY = wrMinY; wrY <= wrMaxY; wrY++)
+            for(int y = _y0; y <= _y1; y++)
             {
-                int realWrY = wrY % renderChunksTall;
-                if(realWrY < 0)
+                int yy = y % yChunks;
+                if(yy < 0)
                 {
-                    realWrY += renderChunksTall;
+                    yy += yChunks;
                 }
-                for(int wrZ = wrMinZ; wrZ <= wrMaxZ; wrZ++)
+                for(int z = _z0; z <= _z1; z++)
                 {
-                    int realWrZ = wrZ % renderChunksDeep;
-                    if(realWrZ < 0)
+                    int zz = z % zChunks;
+                    if(zz < 0)
                     {
-                        realWrZ += renderChunksDeep;
+                        zz += zChunks;
                     }
-                    int i = (realWrZ * renderChunksTall + realWrY) * renderChunksWide + realWrX;
-                    ChunkRenderer worldrenderer = chunkRenderers[i];
-                    if(!worldrenderer.dirty)
+                    int p = (zz * yChunks + yy) * xChunks + xx;
+
+                    ChunkRenderer renderer = chunkRenderers[p];
+                    if(!renderer.dirty)
                     {
-                        chunkRenderersToUpdate.add(worldrenderer);
-                        worldrenderer.setDirty();
+                        dirtyChunks.add(renderer);
+                        renderer.setDirty();
                     }
                 }
             }
